=== debian/control ===
Source: uclibc-toolchain
Section: devel
Priority: extra
Maintainer: Simon Richter <sjr@debian.org>
Build-Depends: debhelper (>= 5)
Standards-Version: 3.7.2

Package: uclibc-toolchain
Architecture: any
Depends: g++-4.1 (= ${target:GCCVersion}), libuclibc-dev
Description: Toolchain alias for building against uclibc
 This package provides wrapper scripts for the toolchain, providing an
 alternate host triplet for building against uclibc.
